package com.guams.review.controller;

import com.guams.review.modele.User;
import com.guams.review.service.UserService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpEntity;
import org.springframework.http.HttpHeaders;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import java.util.List;
import java.util.Optional;

@RestController
@RequestMapping(path = "api/users")
public class UserController
{
    private final UserService userService;

    @Autowired
    public UserController(UserService userService) {
        this.userService = userService;
    }

    @GetMapping
    public ResponseEntity<List<User>> getUsers()
    {
        List<User> users = userService.getUsers();
        return new ResponseEntity<>(users, new HttpHeaders(),HttpStatus.OK);
    };

    @PostMapping
    public ResponseEntity<String> saveUser(@RequestParam User user)
    {
        userService.saveUser(user);
        Optional<User> exists = userService.findById(user.getId());
        if (exists.isPresent())
        {
            return new ResponseEntity<>("Created", new HttpHeaders(), HttpStatus.CREATED);
        }
        return new ResponseEntity<>("Error", new HttpHeaders(), HttpStatus.INTERNAL_SERVER_ERROR);
    }
}
